#version 330

uniform sampler2D colorTexture;

uniform vec3 sunLightDir;
uniform vec3 sunLightCol;
uniform float sunLightInt;
uniform vec3 ambLightCol;
uniform float ambLightInt;
uniform float specLightInt;
uniform float shininess;

uniform vec4 objectColor;

in vec2 fUVs;
in vec3 N; //normal
in vec3 V; //view
in vec3 P; //position

out vec4 fragColor;
 
void main() {
	vec4 tex = texture(colorTexture, fUVs);

	float alpha = objectColor.a * tex.g; //texture is greyscale = alpha value;
	vec3 C = objectColor.rgb;

	vec3 L = -(sunLightDir);
	vec3 H = normalize(V)+normalize(L);

	float cosNL = max(dot(normalize(N),normalize(L)),0);

	vec3 ambColor = ambLightCol*(ambLightInt*2);
	vec3 sunColor = sunLightCol*((1-ambLightInt)*sunLightInt);
	vec3 specColor = sunLightCol*specLightInt;

	float dif_factor = cosNL;
	float spec_factor = cosNL * pow(max(dot(normalize(N), H), 0),shininess);

	//vec3 dif = vec3(C.r*dif_factor, C.g*dif_factor, C.b*dif_factor);

	vec3 dif = sunColor * dif_factor;

	//vec3 dif = C*((ambLightCol*ambLightInt)+(1-ambLightInt*(sunLightCol*dif_factor)));
	
	vec3 spec = specColor*spec_factor;

	vec3 color = (C.rgb * ambColor);
		
	fragColor = vec4((color)+((dif+spec)*0.5), alpha);
	//fragColor = tex;
}