#version 330
in vec3 position;
in vec3 normal;
in vec2 uv;

//uniform vec3 sunLightDir;
//uniform vec3 sunLightCol;
//uniform float sunLightInt;
//uniform vec3 ambLightCol;
//uniform float ambLightInt;
//uniform float shininess;
//uniform float specLightInt;

uniform vec3 view; //cameraLocation
uniform mat4 currentMatrix; //ModelViewProjection
uniform mat4 modelMatrix;
//uniform mat4 normalMatrix;

out vec3 vertViewDist;

out vec2 fUVs;
out vec3 P;
out vec3 N;
out vec3 V;

void main() {
	fUVs = uv;
	gl_Position = currentMatrix * vec4(position, 1);

	P = (modelMatrix * vec4(position,0)).xyz;
	//N = vec3(normalMatrix * vec4(normal, 0));
	N = (modelMatrix * vec4(normal, 0)).xyz;
	//N = normal;
	V = view - P;

	vertViewDist = view - (modelMatrix * vec4(position, 1.0)).xyz;
}